#!/bin/bash

#FILE: doit.sh 
# VERSION: 0.1.2
# COPYRIGHT: miltonjohn 
#LICENSE: not specified ;)
#Description: kanotix-workaround-script
#to get keys, packages, scripts.
#For Kanotix there are special functions like kernel and automatic 3D-driver nvidia/fglrx/intel-(fix)-installation
#TODO: update of script when Kanotix is based on Debian 5.0 Codename: Lenny, when new IOurbanterror is released!


/etc/init.d/kdm stop
#no root!
if [ "$(id -u)" != 0 ]; then
 echo Error: You must be root to run this script! >&2
 exit 6
fi

#debian-version not found
if [ ! -f /etc/debian_version ]; then
 echo Error: No Debian compatible system found. Do not ask for support! >&2
 exit 100	
fi

#no Kano
echo -en "\033[0;32m"
if [ ! -f /etc/kanotix-version ]; then
 echo "No Kanotix found! and EXIT !"
 echo -e "\033[0m"
	exit
fi

#read1
read -p "Did you edit Get-it-texts for apt??? (y/n)"
if [ $REPLY = "n" ]; then
	echo "Hurry up - go and edit those files to your needs!"
	exit
fi


####################################################################################################################################################################################################################################################################################################################
###set variables-#set variables-#set variables-#set variables-#set variables-#set variables-#set variables-#set variables-#set variables-#set variables-##
#varname1
var1=$(getent passwd 1000 | cut -d":" -f6 )
#varname2
var2=$(getent passwd 1000 | cut -d":" -f1 )
#varname3 
var3=http://www.kanotix.com/files/install-fglrx-debian.sh
#varname4
var4=http://www.kanotix.com/files/install-nvidia-debian.sh
#varname5
var5=ftp://ftp.snt.utwente.nl/pub/games/urbanterror/UrbanTerror_41_FULL.zip
#varname6
var6=http://kanotix.com/files/kernel/kernel-update-pack-generic.tar.gz
#varname7
var7=$( cat /etc/debian_version )
#varname8
var8=$var1/linux
#varname9
var9=$var1/linux/kernel-raw
#varname10
var10=$var1/linux/design
#varname11
var11=$var1/linux/design/icons
#varname12
var12=$var1/linux/design/k3b_icons
#varname13
var13=$var1/linux/design/k3b_themes
#varname14
var14=$var1/linux/design/mouse
#varname15
var15=$var1/linux/design/wallpaper
#varname16
var16=$var1/linux/debs
#varname17
var17=$var1/comands
#varname18
var18=$var1/isos
#varname19
var19=$var1/pics
#varname20
var20=$var1/movies
#varname21
var21=$var1/music
#varname22
var22=$var1/pods
#varname23
var23=$var1/pdf
#varname24
var24=$var1/games
#varname25
var25=/usr/local/bin
#varname26
var26=/etc/apt/sources.list.d
#varname27
var27=$var1/mjölnir/list
#varname28
var28=$var1/mjölnir/paste
#varname29
var29=/usr/bin
#varname30
var30=http://extras.741.com/extras
#var31
var31=/usr/share/apps/konversation/scripts/
#var32
var32=techpatterns.com/inxi
#var33
var33=techpatterns.com/smxi.zip

####################################################################################################################################################################################################################################################################################################################
###set functions-#set functions-#set functions-#set functions-#set functions-#set functions-#set functions-#set functions-#set functions-#set functions-##
#func1-fglrx
func1 ()
{
cd $var25 
wget $var3
}

#func2-nvidia
func2 ()
{
cd $var25
wget $var4
}

#func3-IOUT
func3 ()
{
cd $var24
wget $var5
unzip UrbanTerror_41_FULL.zip
cd $var24/UrbanTerror_41_FULL/UrbanTerror
chmod +x ioUrbanTerror.i386
}

#func4-kanokernel
func4 ()
{
cd $var9
wget -N $var6; unp kernel-update-pack-generic.tar.gz ; cd $var9/kernel-update-pack-generic ; ./install.sh
}

#func5-rmOOO
func5 ()
{
apt-get remove --purge $(dpkg -l|awk '/openoffice/{print $2}')
}

#func6-DU
func6 ()
{
apt-get update && apt-get dist-upgrade -y
}

#func7-mkdirs
func7 ()
{
mkdir $var8 && chown $var2 -R $var8
mkdir $var9 && chown $var2 -R $var9
mkdir $var10 && chown $var2 -R $var10
mkdir $var11 && chown $var2 -R $var11
mkdir $var12 && chown $var2 -R $var12
mkdir $var13 && chown $var2 -R $var13
mkdir $var14 && chown $var2 -R $var14
mkdir $var15 && chown $var2 -R $var15
mkdir $var16 && chown $var2 -R $var16
mkdir $var17 && chown $var2 -R $var17
mkdir $var18 && chown $var2 -R $var18
mkdir $var19 && chown $var2 -R $var19
mkdir $var20 && chown $var2 -R $var20
mkdir $var21 && chown $var2 -R $var21
mkdir $var22 && chown $var2 -R $var22
mkdir $var23 && chown $var2 -R $var23
mkdir $var24 && chown $var2 -R $var24
}

#func8
func8 ()
{
#repos
if [ $var7 = 4.0 ]; then
if [ ! -f $var26/etch.list ] ; then
cp $var1/mjölnir/repos/etch.list $var26
if [ ! -f $var26/Debian-multimedia.list ] ; then
cp $var1/mjölnir/repos/Debian-multimedia.list $var26
fi
fi
fi

if [ $var7 = 4.0 ]; then
if cat /etc/kanotix-version | grep Thorhammer ; then
if [ ! -f $var26/Kanotix-Thorhammer.list ] ; then
cp $var1/mjölnir/repos/Kanotix-Thorhammer.list $var26
fi
fi
fi

if [ $var7 = 5.0 ]; then
if [ ! -f $var26/lenny.list ] ; then
cp $var1/mjölnir/repos/lenny.list $var26
if [ ! -f $var26/Debian-multimedia-5.list ] ; then
cp $var1/mjölnir/repos/Debian-multimedia-5.list
fi
fi
fi

#if [ cat /etc/kanotix-version =? ] ; then
#cp $var1/mjölnir/repos/Kanotix-?.list $var26
#fi



if [ $var7 = 6.0 ]; then
if [ ! -f $var26/squeeze.list ] ; then
cp $var1/script/repos/squeeze.list $var26
if [ ! -f $var26/Debian-multimedia-6.list ] ; then
cp $var1/script/mjölnir/Debian-multimedia6.list $var26
fi
fi
fi


if [ $var7 = 4.0 ] ; then
echo "$var7"
if [ ! -f $var26/Volatile4.list ] ; then
if cat /etc/apt/sources.list | grep volatile ] ; then
echo "volatile.list found"
else
cp $var1/mjölnir/repos/Volatile4.list $var26
fi
fi
fi


if [ $var7 = 5.0 ] ; then
if [ ! -f $var26/Volatile5.list ] ; then
if cat /etc/apt/sources.list | grep volatile ] ; then
echo "volatile.list found"
else
if [ -f /etc/sidux-version ] ; then
	echo "sidux-found ;)"
else
cp $var1/mjölnir/repos/Volatile5.list $var26
fi
fi
fi
fi


if [ $var7 = 6.0 ] ; then
if [ ! -f $var26/Volatile6.list ] ; then
if cat /etc/apt/sources.list | grep volatile ] ; then
cp $var1/mjölnir/repos/Volatile6.list $var26
fi
fi
fi
}

#func9
func9 ()
{
cd $var29
wget -qO - http://wgetpaste.zlin.dk/wgetpaste-2.12.bz2 | bunzip2 - > $var29/wgetpaste && chmod +x $var29/wgetpaste && chown $var2 $var29/wgetpaste
}

#func10
func10 ()
{
cp $var28/kanotix-info $var25
cp $var28/display-kanotix-info $var25
cp $var28/kanotixpaste $var25
cd $var25 && chmod +x $var25/kanotix-info && chmod +x $var25/display-kanotix-info && chmod +x $var25/kanotixpaste
}

#func11
func11 ()
{
cd $var25 && wget $var30 && chmod +x $var25/extras
}

#func12-inxi
func12 ()
{
cd $var25
wget -Nc $var32 && chmod +x inxi && chown $var2 $var25/inxi
if [ -f /usr/share/apps/konversation/scripts/ ] ; then 
ln -s inxi $var31 
fi
}

#func13
func13 ()
{
cd $var25
wget $var33; unzip smxi.zip
}
####################################################################################################################################################################################################################################################################################################################
########Starting with actions-#Starting with actions-#Starting with actions-#Starting with actions-#Starting with actions-#Starting with actions-#########


echo -en "\033[0;32m"
echo $var1
echo $var2
 
#readoption2
read -p "Is the /home-directory set right? Is the username set correct? (y/n)?"
if [ $REPLY != "y" ]; then
	echo "please insert just the user's name of /home/ 'XYZ': "
	read var2
	echo "Hello $var2!"
	echo "now enter your current directory of 'home' - like /home/Z"
	read var1
	echo "current directory is: $var1"
fi
echo -e "\033[0m"

#mkdirs
func7

#repos
func8

# readkey - Simple Menu with read and if .. elif.
echo -en "\033[0;36m"
clear
until [ "$KEY" = "q" ]; do
# Menü and read
echo -e "Choose Key to proceed\n"
echo -e " 0 - wanna run the entire script?\t\				0"
echo -e " 1 - wanna get Kanotix FGLRX-script and proceed it?\t\		1"
echo -e " 2 - wanna get Kanotix NVIDIA-script and proceed it?\t\		2"
echo -e " 3 - wanna get EXTRAS\t\						3"
echo -e " 4 - wanna get Urban-Terror\t\					4"
echo -e " 5 - wanna get Kanotix-Kernel and proceed it?\t\			5"
echo -e " 6 - wanna remove OOO.org\t\					6"
echo -e " 7 - copy display-script and proceed it to get a overview?!\t\	7"
echo -e " 8 - wanna start Dist-upgrade?\t\					8"
echo -e "Help\t\								h"
echo -e "quit\t\								q \n"
read -n 2 KEY

# show selection
if [ "$KEY" == "0" ] ; then
    echo -e "\nrunning whole script" && break
elif [ "$KEY" == "1" ] ; then
    echo -e "\nfetching Kanos FGLRX-script and proceed"
	func1 && install-fglrx-debian.sh 
elif [ "$KEY" == "2" ] ; then
    echo -e "\nfetching Kanos Nvidia-script and proceed"
	func2 && install-nvidia-debian.sh
elif [ "$KEY" == "3" ] ; then
    echo -e "\nfetching EXTRAS and proceed"
	func11 && apt-get update && extras
	if [ -f $var32/multimedia.list ] ; then
	rm -f $var32/multimedia.list
	fi
elif [ "$KEY" == "4" ] ; then
    echo -e "\nfetching 700MB UrbanTerror"
	func3
elif [ "$KEY" == "5" ] ; then
    echo -e "\nfetching latest KanotixKernel and proceed"
	func4
elif [ "$KEY" == "6" ] ; then
	echo -e "\nremoving OOO.org"
	func5
elif [ "$KEY" == "7" ] ; then
	echo -e "\proceed display-script & wgetpaste"
	func9 && func10 && kanotixpaste -c 'display-kanotix-info'
elif [ "$KEY" == "8" ] ; then
	echo -e "\proceed dist-upgrade"
	if [ -f $var32/multimedia.list ] ; then
	rm -f $var32/multimedia.list
	fi
	func6
elif [ "$KEY" == "h" -o "$KEY" == "H" ] ; then
	clear
    echo -e "\nHelp:
	0  is to run the whole script which ask you some points of this menue or does it silent

	1  get Kano's FGLRX-script to get the ATI-driver installed - Kanotix does fine, Debian-Lenny and Ubuntu shall too

	2  get Kano's Nvidia-script to get the Nvidia-driver installed - Kanotix does fine, Debian-Lenny and Ubuntu shall too

	3  getting extras

	4  fetches the Game UrbanTerror

	5  fetches lates Kanotix-Kernel - just for Kanotix

	6 removes OpenOfficeOrg - handle with care

	7 proceed ModestUser's Display-script - have a look with wgetpaste

	8 proceeds a Dist-Upgrade"
elif [ "$KEY" == "q" -o "$KEY" == "Q" ] ; then
	exit
fi
done
echo -e "\033[0m"

#wgetpaste
func9
func10

#inxi
func12

#smxi
func13

#get-texts
cp $var1/script/list/get.txt $var1


#getkeys 
wget http://debian-multimedia.org/gpgkey.pub -O - | apt-key add - && gpg --keyserver wwwkeys.eu.pgp.net --recv-keys 4E3866DB | apt-key add /root/.gnupg/pubring.gpg && wget http://download.tuxfamily.org/shames/A42A6CF5.gpg -O- | apt-key add - && wget -O - http://deb.opera.com/archive.key | apt-key add - && gpg --keyserver wwwkeys.eu.pgp.net --recv-keys 12345678 && gpg --export 12345678 | apt-key add - && wget -q http://www.debian.org/volatile/etch-volatile.asc -O- | sudo apt-key add - && wget -O - http://packages.kirya.net/Kirya.netDebianpackagesVerificationKey.asc | apt-key add -
for k in $(apt-get update 2>&1|grep -o NO_PUBKEY.*|sed 's/NO_PUBKEY //');do gpg --recv-keys --keyserver wwwkeys.eu.pgp.net $k;gpg --armor --export $k|apt-key add -;done
wget -q http://apt.wicd.net/wicd.gpg -O- | sudo apt-key add -


#apt-get update
apt-get update

#apt-get install
########################################################windowmanager_for_specify_getit.txt###############
if env | grep KDE_FULL_SESSION ;
then
cd $var1
for x in $(<get.txt); do apt-get install -y $x; done
fi

#codec: 
sh /usr/share/doc/kaffeine/install-css.sh

#extras
echo -en "\033[0;32m"
#readoption3
read -p "Want to get EXTRAS (y/n)?"
if [ $REPLY = "y" ]; then
	echo "go get it after script just typ extras"
	func11
elif [ $REPLY = "n" ]; then
	echo "going on the normal way of script"
fi
echo -e "\033[0m"

#fix-apt-install
apt-get install -f

#clean
apt-get clean

#get UrbanTerror
echo -en "\033[0;32m"
#readoption4
read -p "Want to get the latest UrbanTerror - bout 700MB to download (y/n)?"
if [ $REPLY = "y" ]; then
	echo "go get it"
	func3
elif [ $REPLY = "n" ]; then
	echo "going on the normal way of script"
fi
echo -e "\033[0m"

#rkhunter
apt-get install -y clamav rkhunter; rkhunter --update && rkhunter -c

#ooo-remove:
echo -en "\033[0;32m"
#readoption4
read -p "Want to remove OOO.org (y/n)?"
if [ $REPLY = "y" ]; then
	echo "go drop it"
	func5
elif [ $REPLY = "n" ]; then
	echo "going on the normal way of script"
fi
echo -e "\033[0m"

#upgrade
apt-get update
if echo $LANG | grep de_DE.UTF-8 ; 
then echo de_DE.UTF-8 UTF-8 > /etc/locale.gen && apt-get dist-upgrade -y
else apt-get dist-upgrade -y
fi

#new-kernel
#readoption5
read -p "Want to get latest kernel (y/n)?"
if [ $REPLY = "y" ]; then
func4
elif [ $REPLY = "n" ]; then
echo "no new Kernel- ok so proceed"
fi

#update scripts and fglrx or nvidia
update-scripts-kanotix.sh 
cd $var1 

#get right 3d-driver
#readopton6
read -p "Want to get right 3D-driver (y/n)?"
if [ $REPLY = "y" ]; then
if lspci | grep nVidia ;
then /etc/init.d/kdm stop && install-nvidia-debian.sh
elif lspci | grep INTEL ;
then echo deb http://kanotix.com/files/fix/xorg-intel ./ > $var26/xorg.list && apt-get update && apt-get dist-upgrade
echo -en "\033[0;32m"
echo "...and (#3) Hint: Use Driver intel in /etc/X11/xorg.conf for new Intel onboard VGA., or (#4) apt-get install xserver-xorg-video-intel=2:2.1.1-4, or (#5) echo xserver-xorg-video-intel hold|dpkg --set-selections, or (#6) run sgfxi"
echo -e "\033[0m"
elif lspci | grep ATI ;
then /etc/init.d/kdm stop && install-fglrx-debian.sh

fi
elif [ $REPLY = "n" ]; then
echo "done."
fi
exit